#include <ESP8266WiFi.h>
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include "Adafruit_MQTT.h"
#include "Adafruit_MQTT_Client.h"


#define WLAN_SSID       "Server"
#define WLAN_PASS       "Password"
/* Adafruit.io Setup */
#define AIO_SERVER      "io.adafruit.com"
#define AIO_SERVERPORT  1883                   // use 8883 for SSL
#define AIO_USERNAME    "lalith_kk"
#define AIO_KEY         "aio_kXDx78sZlrMnpcgxqv0G7oFzgfY2"

#define LED_BUILTIN 16
unsigned long SENSOR1 = D2;
unsigned long SENSOR2 = D3;
long currentMillis = 0;
long previousMillis = 0;
int interval = 1000;
boolean ledState = LOW;
float calibrationFactor = 4.5;
volatile byte pulseCount=0;
volatile byte pulseCount2=0;

byte pulse1Sec = 0;
byte pulse2Sec=0;
float flowRate1=0.0;
float flowRate2=0.0;
unsigned long flowMilliLitres1=0;
unsigned long flowMilliLitres2=0;
unsigned int totalMilliLitres1=0;
unsigned int totalMilliLitres2=0;
float flowLitres1;
float flowLitres2;
float totalLitres1;
float totalLitres2;

unsigned int relay = D5;
void IRAM_ATTR pulseCounter()
{
  pulseCount++;
 
}

void IRAM_ATTR pulseCounter2()
{
  pulseCount2++;
 
}

/* Global State (you don't need to change this!) */
// Create an ESP8266 WiFiClient class to connect to the MQTT server.
WiFiClient client;
// or... use WiFiFlientSecure for SSL
//WiFiClientSecure client;
// Setup the MQTT client class by passing in the WiFi client and MQTT server and login details.
Adafruit_MQTT_Client mqtt(&client, AIO_SERVER, AIO_SERVERPORT, AIO_USERNAME, AIO_KEY);
/* Feeds **/
// Setup a feed called 'photocell' for publishing.
// Notice MQTT paths for AIO follow the form: <username>/feeds/<feedname>

Adafruit_MQTT_Publish fr = Adafruit_MQTT_Publish(&mqtt, AIO_USERNAME "/feeds/flowrate1");
Adafruit_MQTT_Publish v = Adafruit_MQTT_Publish(&mqtt, AIO_USERNAME "/feeds/flowrate2");

/* Sketch Code **/
// Bug workaround for Arduino 1.6.6, it seems to need a function declaration
// for some reason (only affects ESP8266, likely an arduino-builder bug).
void MQTT_connect();
void setup()
{
  Serial.begin(115200);

  delay(10);

  Serial.println(F("Adafruit MQTT demo"));
  // Connect to WiFi access point.
  Serial.println(); Serial.println();
  Serial.print("Connecting to ");
  Serial.println(WLAN_SSID);
  WiFi.begin(WLAN_SSID, WLAN_PASS);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println();
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());

  pinMode(LED_BUILTIN, OUTPUT);
  
  pinMode(SENSOR1, INPUT);
  digitalWrite(SENSOR1, HIGH);

  pinMode(SENSOR2, INPUT);
  digitalWrite(SENSOR2, HIGH);

  pinMode(relay, OUTPUT);
  
 
  attachInterrupt(digitalPinToInterrupt(SENSOR1), pulseCounter, FALLING);
  //delay(10);
  attachInterrupt(digitalPinToInterrupt(SENSOR2), pulseCounter, FALLING);
 
}
uint32_t x=0;
void loop()
 {
  MQTT_connect();
  
  long currentMillis = millis();
  if (currentMillis - previousMillis > 1000) 
  {
    
   // Disable the interrupt while calculating flow rate and sending the value to
    // the host
    detachInterrupt(digitalPinToInterrupt(SENSOR1));
    detachInterrupt(digitalPinToInterrupt(SENSOR2));
        
    // Because this loop may not complete in exactly 1 second intervals we calculate
    // the number of milliseconds that have passed since the last execution and use
    // that to scale the output. We also apply the calibrationFactor to scale the output
    // based on the number of pulses per second per units of measure (litres/minute in
    // this case) coming from the sensor.
    flowRate1 = ((1000.0 / (currentMillis - previousMillis)) * pulseCount) / calibrationFactor;
    flowRate2 = ((1000.0 / (currentMillis - previousMillis)) * pulseCount2) / calibrationFactor;
    
    // Note the time this processing pass was executed. Note that because we've
    // disabled interrupts the millis() function won't actually be incrementing right
    // at this point, but it will still return the value it was set to just before
    // interrupts went away.
    previousMillis = millis();
    
    // Divide the flow rate in litres/minute by 60 to determine how many litres have
    // passed through the sensor in this 1 second interval, then multiply by 1000 to
    // convert to millilitres.
    flowMilliLitres1 = (flowRate1 / 60) * 1000;
    flowMilliLitres2 = (flowRate2 / 60) * 1000;
    
    // Add the millilitres passed in this second to the cumulative total
    totalMilliLitres1 += flowMilliLitres1;
    totalMilliLitres2 += flowMilliLitres2;
      
    unsigned int frac;
    
    // Print the flow rate for this second in litres / minute
    Serial.print("Flow rate1: ");
    Serial.print(int(flowRate1));  // Print the integer part of the variable
    Serial.print("L/min");
    Serial.print("\t"); 		  // Print tab space

    Serial.print("Flow rate2: ");
    Serial.print(int(flowRate2));  // Print the integer part of the variable
    Serial.print("L/min");
    Serial.print("\t");

    // Print the cumulative total of litres flowed since starting
    Serial.print("Output Liquid Quantity1: ");        
    Serial.print(totalMilliLitres1);
    Serial.println("mL"); 
    Serial.print("\t"); 		  // Print tab space
  	Serial.print(totalMilliLitres1/1000);
	  Serial.print("L");

    Serial.print("Output Liquid Quantity2: ");        
    Serial.print(totalMilliLitres2);
    Serial.println("mL"); 
    Serial.print("\t"); 		  // Print tab space
  	Serial.print(totalMilliLitres2/1000);
	  Serial.print("L");
    

    // Reset the pulse counter so we can start incrementing again
    pulseCount = 0;
    pulseCount2 = 0;
    
    // Enable the interrupt again now that we've finished sending output
    attachInterrupt(digitalPinToInterrupt(SENSOR1), pulseCounter, FALLING);
    attachInterrupt(digitalPinToInterrupt(SENSOR2), pulseCounter2, FALLING);
  }

  delay(10000);
 fr.publish(flowRate1);
 fr.publish(flowRate2);
 delay(5000);
 
  v.publish(totalLitres1);
  v.publish(totalLitres2);

  delay(1000);

  float difference = (totalMilliLitres1 - totalMilliLitres2);
  Serial.println(difference);
  if( difference > 50.0 )
  {
    digitalWrite(relay,LOW);
    Serial.println("There's a leakkk!");
  }
  else
  {
    digitalWrite(relay,HIGH);
  }
  
    }


void MQTT_connect() {
  int8_t ret;
  // Stop if already connected.
  if (mqtt.connected()) {
    return;
  }
  Serial.print("Connecting to MQTT... ");
  uint8_t retries = 3;
  while ((ret = mqtt.connect()) != 0) { // connect will return 0 for connected
       Serial.println(mqtt.connectErrorString(ret));
       Serial.println("Retrying MQTT connection in 5 seconds...");
       mqtt.disconnect();
       delay(5000);  // wait 5 seconds
       retries--;
       if (retries == 0) {
         // basically die and wait for WDT to reset me
         while (1);
       }
  }
  Serial.println("MQTT Connected!");
}